// File:	DiceMan\\Bmp.cpp
// Purpose:	Lumdum Dare 48 Hour Contest Game
// Theme:	Random
// Author:	James Watson

#include "diceman.h"

Bmp *BMP_Load(char *szName,int flags)
{
	Bmp *bmp=new Bmp();

	bmp->bmp=SDL_LoadBMP(szName);

	if (bmp->bmp==NULL)
	{
		delete bmp;
		return NULL;
	}
	if (flags & BMP_COLORKEY)
	{
		bmp->key=SDL_MapRGB(bmp->bmp->format,255,0,255);
		SDL_SetColorKey(bmp->bmp,SDL_SRCCOLORKEY,bmp->key);
	}
	bmp->w=bmp->bmp->w;
	bmp->h=bmp->bmp->h;

	return bmp;
}

Bmp *BMP_LoadSprite(char *szName,int w,int h)
{
	Bmp *bmp=new Bmp();

	bmp->bmp=SDL_LoadBMP(szName);

	if (bmp->bmp==NULL)
	{
		delete bmp;
		return NULL;
	}

	bmp->key=SDL_MapRGB(bmp->bmp->format,255,0,255);
	SDL_SetColorKey(bmp->bmp,SDL_SRCCOLORKEY,bmp->key);

	bmp->w=w;//bmp->bmp->w/w;
	bmp->h=h;//bmp->bmp->h/h;

	return bmp;
}


void BMP_Render(Bmp *bmp,int x,int y,int flags)
{
	SDL_Rect rect;

	if (flags & BMP_HCENTER)
		rect.x=x-(bmp->w>>1);
	else if (flags & BMP_RIGHT)
		rect.x=x-bmp->w;
	else
		rect.x=x;

	if (flags & BMP_VCENTER)
		rect.y=y-(bmp->h>>1);
	else if (flags & BMP_BOTTOM)
		rect.y=y-bmp->h;
	else
		rect.y=y;

	SDL_BlitSurface(bmp->bmp,NULL,g_MainWindow,&rect);
}

void BMP_RenderSprite(Bmp *bmp,int x,int y,int seq,int frame)
{
	SDL_Rect src,dest;

	dest.x=x;
	dest.y=y;
	src.x=frame*bmp->w;
	src.y=seq*bmp->h;
	src.w=bmp->w;
	src.h=bmp->h;

	SDL_BlitSurface(bmp->bmp,&src,g_MainWindow,&dest);
}

void BMP_Free(Bmp *bmp)
{
	SDL_FreeSurface(bmp->bmp);

	delete bmp;
}