// File:	DiceMan\\Diceman.h
// Purpose:	Lumdum Dare 48 Hour Contest Game
// Theme:	Random
// Author:	James Watson

#ifndef _DICEMAN_H
#define _DICEMAN_H

#include "SDL.h"
#include "SDL_mixer.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define VERSION_MAIN	"1"
#define VERSION_REV		"0"

#define MODE_TITLE	0
#define MODE_GAME	1
#define MODE_OPTIONS 2
#define MODE_HELP 3
#define MODE_GAMEOVER 4
#define MODE_FINISH 5
#define MODE_GAMELEVEL 6
#define MODE_HIGHSCORE 7
#define MODE_GAMEEND 8

#define DICE_RED	0
#define DICE_GREEN	1
#define DICE_BLUE	2
#define DICE_WHITE	3

extern SDL_Surface *g_MainWindow;

extern int g_sfxVol;

void MODE_Set(int mode);

typedef struct {
	void  (*Init)(void);
	bool (*Update)(void);
	void (*Render)(void);
	void (*Close)(void);
} GameMode;

typedef struct {
	char  name[20];
	int	  score;
} HighScore;

extern HighScore g_high[];

extern GameMode *g_Mode;
extern int g_rerolls[4];

extern Mix_Music *music;
extern Mix_Chunk *knock;
extern Mix_Chunk *scream;
extern Mix_Chunk *footfall;
extern Mix_Chunk *explode;
extern Mix_Chunk *dicethrow;

void MAIN_PlaySfx(Mix_Chunk *sfx);

// Include game file headers here

#include "font.h"
#include "bmp.h"
#include "entity.h"
#include "particle.h"

#include "title.h"
#include "game.h"
#include "options.h"
#include "help.h"
#include "finish.h"
#include "gameover.h"
#include "highscore.h"
#include "gameend.h"


#endif