// File:	DiceMan\\Entity.cpp
// Purpose:	Lumdum Dare 48 Hour Contest Game
// Theme:	Random
// Author:	James Watson

#include "diceman.h"

Entity pentities[32];
Bmp *g_entitySpr;

void ENTITY_Init(void)
{
	int i;

	for(i=0;i<32;i++)
		pentities[i].used=false;

	g_entitySpr=BMP_LoadSprite("gfx/enemy.bmp",32,48);
}

void ENTITY_CleanUp(void)
{
	int i;

	for(i=0;i<32;i++)
		pentities[i].used=false;
}

void ENTITY_Close(void)
{
	BMP_Free(g_entitySpr);
}


void ENTITY_Create(int x,int y,int type)
{
	int i;

	Entity *p=NULL;
	
	for(i=0;i<32;i++)
		if (pentities[i].used==false)
			p=&pentities[i],i=32;

	if (p==NULL)
		return;

	p->used=true;
	p->bmp=g_entitySpr;
	p->type=type;
	p->x=x;
	p->y=y;
	p->dir=rand()%1;
}

void ENTITY_Render()
{
	int i;
	Entity *p=pentities;

	for(i=0;i<32;i++,p++)
		if (p->used)
		{
			BMP_RenderSprite(p->bmp,p->x-16-g_scroll,p->y-48,p->type,p->frame>>2);
		}
}

Entity *ENTITY_Collide(int x,int y)
{
	int dx,dy,i;
	Entity *p=pentities;

	for(i=0;i<32;i++,p++)
		if (p->used)
		{
			dx=abs(p->x-x);
			dy=abs(p->y-y);

			if ((dx<24)&&(dy<32))
				return p;
		}
	return NULL;
}

void ENTITY_Destroy(Entity *ent)
{
	ent->used=false;
}

void ENTITY_UpdateEntity(Entity *p)
{
	int x,y,cur,curx;

	curx=p->x/80;
	y=p->y/80;

	cur=map[(y*g_mapWidth)+curx];

	if (p->dir==0)
	{
		p->x+=2;
		x=(p->x+20)/80;
	}
	else
	{
		p->x-=2;
		x=(p->x-20)/80;
	}


	p->frame=(p->frame+1)%16;

	if (curx==x)
		return;

	switch(cur)
	{
	case 2:
		if (p->dir==1)
		{
			p->dir=0;
			return;
		}
		break;
	case 3:
		if (p->dir==0)
		{
			p->dir=1;
			return;
		}
		break;
	}

	switch(map[(y*g_mapWidth)+x])
	{
	case 0:
	case 5:
	case 4:
		p->dir=1-p->dir;
		break;
	case 2:
		// Turn only if we try to enter the barred side
		if (p->dir==0)
			p->dir=1;
		break;
	case 3:
		// Turn only if we try to enter the barred side
		if (p->dir==1)
			p->dir=0;
		break;
	}
}

void ENTITY_Update()
{
	int i;
	Entity *p=pentities;

	for(i=0;i<32;i++,p++)
		if(p->used)
		{
			ENTITY_UpdateEntity(p);

		}
}

