// File:	DiceMan\\Finish.cpp
// Purpose:	Lumdum Dare 48 Hour Contest Game
// Theme:	Random
// Author:	James Watson

#include "diceman.h"

GameMode FINISH_Info={FINISH_Init,FINISH_Update,FINISH_Render,FINISH_Close};


Bmp *fin_dice;

int g_bonus[5];
int g_liveBonus;
int g_bonusWait;

void FINISH_Init(void)
{
	int i;

	fin_dice=BMP_LoadSprite("gfx/paneldice.bmp",32,32);
	g_liveBonus=g_lives;

	for(i=0;i<5;i++)
		g_bonus[i]=0;

	g_bonusWait=0;

	PARTICLE_Init();
	g_scroll=0;
}

void FINISH_Render(void)
{
	char str[32];
	int i;

	TITLE_Background();

	BMP_Render(g_SmallLogo,320,16,BMP_HCENTER);

	FONT_Render(g_BigFont,320,120,"Bonus",FONT_HCENTER);

	sprintf(str,"%d",g_bonus[0]);
	BMP_RenderSprite(fin_dice,128,160,0,0);
	FONT_Render(g_BigFont,512,160,str,FONT_RIGHT);

	for(i=0;i<4;i++)
	{
		// Check if we've finished adding up the previous bonuses
		if (g_bonus[i+1]==0)
			continue;

		sprintf(str,"%d",g_bonus[i+1]);

		if (i==3)
			FONT_Render(g_BigFont,128,200+40*i,"Lives",FONT_NORMAL);
		else
			BMP_RenderSprite(fin_dice,128,200+40*i,i+1,i+1);

		FONT_Render(g_BigFont,512,200+40*i,str,FONT_RIGHT);
	}

	FONT_Render(g_BigFont,128,400,"Total",FONT_NORMAL);
	sprintf(str,"%d",g_bonus[0]+g_bonus[1]+g_bonus[2]+g_bonus[3]+g_bonus[4]);
	FONT_Render(g_BigFont,512,400,str,FONT_RIGHT);

	PARTICLE_Render();
}

extern int g_level;

bool FINISH_Update(void)
{
	int i;

	SDL_Event event;

	if (g_bonusWait)
	{
		g_bonusWait--;
		return false;
	}

	g_bonusWait=6;


	for(i=0;i<4;i++)
	{
		if (g_rerolls[i])
		{
			g_rerolls[i]--;
			g_bonus[i]+=(i+1)*100;
			g_score+=(i+1)*100;
			PARTICLE_Create(504,176+40*i,2);
			MAIN_PlaySfx(knock);
			return false;
		}
	}

	if (g_liveBonus)
	{
		g_liveBonus--;
		g_bonus[4]+=500;
		g_score+=500;
		PARTICLE_Create(504,176+40*4,2);
		MAIN_PlaySfx(knock);
		return false;
	}

	while(SDL_PollEvent(&event))
	{
		switch(event.type)
		{
		case SDL_KEYDOWN:
			switch(event.key.keysym.sym)
			{

			case SDLK_ESCAPE:
				MODE_Set(MODE_TITLE);
				break;

			case SDLK_RETURN:
			case SDLK_SPACE:
				if (g_level==5)
					MODE_Set(MODE_GAMEEND);
				else
					MODE_Set(MODE_GAMELEVEL);
				break;
			}
		}
	}


	return false;
}

void FINISH_Close(void)
{
	BMP_Free(fin_dice);
	PARTICLE_Close();
}