// File:	DiceMan\\Help.cpp
// Purpose:	Lumdum Dare 48 Hour Contest Game
// Theme:	Random
// Author:	James Watson

#include "diceman.h"

GameMode HELP_Info={HELP_Init,HELP_Update,HELP_Render,HELP_Close};

int g_helpFrame;

char *helpStr[]={
	"Help DiceMan make it to the exit of each level",
	"by collecting the dice to change the level.",
	"Red Dice remove a block, Green place a platform.",
	"Blue removes an enemy. The row is determined by the",
	"number showing above DiceMan's head.",
	"",
	"Use cursors to move, jump and drop through platforms.",
	"Use SPACE to re-roll DiceMan's head.",
	"F1,F2 and F3 roll the Red,Green and Blue dice.",
	"",
	"Can you make it to the exit of each level?"
};

void HELP_Init(void)
{
	g_helpFrame=0;
}

void HELP_Render(void)
{
	int i;

	TITLE_Background();

	BMP_Render(g_SmallLogo,320,16,BMP_HCENTER);

	FONT_RenderSpecial(g_BigFont,g_BigDarkFont,320,140,"DiceMan Help",(g_helpFrame>>2)%16,FONT_HCENTER);

	for(i=0;i<11;i++)
	{
		FONT_Render(g_Font,320,204+20*i,helpStr[i],FONT_HCENTER);
	}
}

bool HELP_Update(void)
{
	SDL_Event event;

	g_helpFrame++;

	while(SDL_PollEvent(&event))
	{
		switch(event.type)
		{
		case SDL_KEYDOWN:
			switch(event.key.keysym.sym)
			{
			case SDLK_ESCAPE:

			case SDLK_RETURN:
				MAIN_PlaySfx(dicethrow);
				MODE_Set(MODE_TITLE);
				break;
			}
		}
	}

	return false;
}

void HELP_Close(void)
{

}