// File:	DiceMan\\Highscore.cpp
// Purpose:	Lumdum Dare 48 Hour Contest Game
// Theme:	Random
// Author:	James Watson

#include "diceman.h"

GameMode HIGHSCORE_Info={HIGHSCORE_Init,HIGHSCORE_Update,HIGHSCORE_Render,HIGHSCORE_Close};

bool g_scoreEntry;
int g_scorePos;
int g_pos;
int g_fireworkTimer;

void HIGHSCORE_Init(void)
{
	SDL_EnableUNICODE(SDL_ENABLE);

	if (g_scoreEntry)
	{
		int i=4;
		while((i>=0)&&(g_score>g_high[i].score))
		{
			if (i<4)
				g_high[i+1]=g_high[i];

			g_high[i].score=g_score;
			g_high[i].name[0]=0;
			i--;
		}
		g_scorePos=i+1;
		g_pos=0;
	}
	PARTICLE_Init();

	g_scroll=0;
	g_fireworkTimer=15;
}

void HIGHSCORE_Render(void)
{
	char str[32];
	int i;

	TITLE_Background();		   
	
	BMP_Render(g_SmallLogo,320,16,BMP_HCENTER);

	FONT_Render(g_BigFont,320,120,"High Scores",FONT_HCENTER);

	for(i=0;i<5;i++)
	{
		sprintf(str,"%d",i+1);
		FONT_Render(g_BigFont,64,160+i*40,str,FONT_NORMAL);
		if (g_scoreEntry && (i==g_scorePos))
		{
			sprintf(str,"%s_",g_high[i].name);
			FONT_RenderSpecial(g_BigFont,g_BigDarkFont,128,160+i*40,str,g_pos,FONT_NORMAL);
		}
		else
			FONT_Render(g_BigFont,128,160+i*40,g_high[i].name,FONT_NORMAL);

		sprintf(str,"%d",g_high[i].score);

		FONT_Render(g_BigFont,596,160+i*40,str,FONT_RIGHT);
	}

	PARTICLE_Render();
}

bool HIGHSCORE_Entry(void)
{
	SDL_Event event;
	char ch;

	while(SDL_PollEvent(&event))
	{
		switch(event.type)
		{
		case SDL_KEYDOWN:
			MAIN_PlaySfx(knock);
			PARTICLE_Create(136+FONT_Length(g_BigFont,g_high[g_scorePos].name),176+g_scorePos*40,2);

			if ( (event.key.keysym.unicode & 0xFF80) == 0 ) 
			{
				ch = event.key.keysym.unicode & 0x7F;
				switch(ch)
				{
				case 127:
				case 8:
					if (g_pos>0)
						g_high[g_scorePos].name[--g_pos]=0;
					break;
				case 13:
				case 10:
				case 27:
					g_scoreEntry=false;
					g_fireworkTimer=15;
					break;
				default:
					if ((ch<32)||(ch>126))
						break;
					if (g_pos<15)
					{
						g_high[g_scorePos].name[g_pos++]=ch;
						g_high[g_scorePos].name[g_pos]=0;
					}
					break;
				}

			}
		}
	}

	return false;
}

bool HIGHSCORE_Update(void)
{
	SDL_Event event;

	if (g_scoreEntry)
		return HIGHSCORE_Entry();

	g_fireworkTimer--;

	if (g_fireworkTimer==0)
	{
		PARTICLE_Create(((rand()%64)*8)+64,((rand()%48)*8)+48,2|PARTICLE_FIREWORK);
		g_fireworkTimer=3;
	}

	while(SDL_PollEvent(&event))
	{
		switch(event.type)
		{
		case SDL_KEYDOWN:
			switch(event.key.keysym.sym)
			{
			case SDLK_ESCAPE:
			case SDLK_RETURN:
			case SDLK_SPACE:
				MAIN_PlaySfx(dicethrow);
				MODE_Set(MODE_TITLE);
				break;
			}
		}
	}

	return false;
}

void HIGHSCORE_Close(void)
{
	PARTICLE_Close();
	SDL_EnableUNICODE(SDL_DISABLE);
}