// File:	DiceMan\\Options.cpp
// Purpose:	Lumdum Dare 48 Hour Contest Game
// Theme:	Random
// Author:	James Watson

#include "diceman.h"

GameMode OPTIONS_Info={OPTIONS_Init,OPTIONS_Update,OPTIONS_Render,OPTIONS_Close};

int optOpt;

char *optStr[]={"Sound Volume","Return"};

void OPTIONS_Init(void)
{
	optOpt=0;
	PARTICLE_Init();
}

void OPTIONS_Render(void)
{
	int i;

	TITLE_Background();

	BMP_Render(g_SmallLogo,320,16,BMP_HCENTER);

	for(i=0;i<2;i++)
	{
		FONT_Render(optOpt==i?g_BigFont:g_BigDarkFont,320,224+96*i,optStr[i],FONT_HCENTER);
		if (i==0)
		{
			char str[12];
			
			strcpy(str,"----------");

			str[g_sfxVol]='|';

			FONT_Render(optOpt==i?g_BigFont:g_BigDarkFont,320,264+64*i,str,FONT_HCENTER);

		}
			
	}

	PARTICLE_Render();
}

void OPTION_Particle(int type)
{
	int w;
	char str[12];

	if (type==0)
	{
		w=FONT_Length(g_BigFont,optStr[optOpt])/2;

		PARTICLE_Create(320-w,240+96*optOpt,2);
		PARTICLE_Create(320+w,240+96*optOpt,2);
	}
	else
	{
		strcpy(str,"----------");
		str[g_sfxVol]='|';
		w=320-FONT_Length(g_BigFont,str)/2;
		str[g_sfxVol+1]=0;
		w+=FONT_Length(g_BigFont,str);
		PARTICLE_Create(w+4,272,2);
	}
}


bool OPTIONS_Update(void)
{
	SDL_Event event;

	while(SDL_PollEvent(&event))
	{
		switch(event.type)
		{
		case SDL_KEYDOWN:
			switch(event.key.keysym.sym)
			{
			case SDLK_UP:
				optOpt=(optOpt+1)%2;
				MAIN_PlaySfx(knock);
				OPTION_Particle(0);
				break;

			case SDLK_DOWN:
				optOpt=(optOpt+1)%2;
				MAIN_PlaySfx(knock);
				OPTION_Particle(0);
				break;

			case SDLK_LEFT:
				MAIN_PlaySfx(knock);
				OPTION_Particle(1);
				switch(optOpt)
				{
				case 0:
					g_sfxVol--;
					if (g_sfxVol<0)
						g_sfxVol=0;
					break;
				}
				break;

			case SDLK_RIGHT:
				MAIN_PlaySfx(knock);
				OPTION_Particle(1);
				switch(optOpt)
				{
				case 0:
					g_sfxVol++;
					if (g_sfxVol>9)
						g_sfxVol=9;
					break;
				}
				break;

			case SDLK_ESCAPE:
				MAIN_PlaySfx(dicethrow);
				MODE_Set(MODE_TITLE);
				break;
			case SDLK_RETURN:
				MAIN_PlaySfx(dicethrow);
				switch(optOpt)
				{
				case 1:
					MODE_Set(MODE_TITLE);
					break;
				}
				break;
			}
		}
	}

	return false;
}

void OPTIONS_Close(void)
{
	PARTICLE_Close();
}